import 'package:imsdk_client_core/src/processor_impl.dart';

class _ProcessorHtml implements ProcessorImpl {
  int _taskIdInc = 0;
  late ProcessorHandler _processorHandler;

  @override
  Future<bool> start(ProcessorHandler processorHandler) {
    _processorHandler = processorHandler;
    return Future.value(true);
  }

  @override
  Future<T?> runTask<T>(String taskType, dynamic taskData) {
    final taskId = _taskIdInc++;
    if (taskType.startsWith('\$') && taskType.endsWith('\$')) {
      final result = _processorHandler.bridgeHandle(ProcessorMessage(taskType, taskId, taskData)) as T;
      return Future.value(result);
    } else {
      final result = _processorHandler.customHandle(ProcessorMessage(taskType, taskId, taskData)) as T;
      return Future.value(result);
    }
  }

  @override
  void destroy() {}
}

ProcessorImpl createProcessor({int? timeout}) {
  return _ProcessorHtml();
}
